#!/usr/bin/env python
# -*- coding: utf-8 -*-

# Insoire by Conbagui's  tutorials https://www.deviantart.com/conbagui/art/Create-a-50th-Anniversary-Moon-Landing-Oreo-cookie-808147689

# author: Pocholo
# date: 3/1/21

# Comments directed to http://gimpchat.com

# Installation:
# This script should be placed in the user plugins folder

# Copyright (C)

#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by   
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.

#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <https://www.gnu.org/licenses/>.#


from gimpfu import *
import os, sys,time 
import gettext
gettext.install("gimp20-python", gimp.locale_directory, unicode=True)

def create_oreo_cookie_text(customtext, fontname, size):
    
    #Initiates defaults
    pdb.gimp_context_set_defaults()
    pdb.gimp_context_set_default_colors()
	        
    #Background and noise combined
    img = pdb.gimp_image_new(1200, 900, RGB_IMAGE)   
    backLayer = pdb.gimp_layer_new(img, img.width, img.height, RGBA_IMAGE, "Background", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, backLayer, 0)
    pdb.gimp_layer_add_alpha(backLayer)
    pdb.gimp_context_set_foreground((116, 160, 255))
    pdb.gimp_context_set_background((0, 78, 255)) 
    pdb.gimp_drawable_fill(backLayer, FILL_FOREGROUND)
    pdb.gimp_edit_blend(backLayer, 
                                0,  #blend mode - fg to bg rgb
                LAYER_MODE_NORMAL,  #paint mode 
                                2,  #gradient type - radial
                              100,  #opacity 
                                0,  #offset
                                0,  #repeat - none
                            FALSE,  #reverse
                             TRUE,  #supe-samle
                                3,  #max depth
                             0.20,  #threshold                            
                             TRUE,  #dither
                              800,  #x1
                              600,  #y1
                             1600,  #x2
                             1200)  #y2
        
    pdb.gimp_display_new(img)
		
	#Create the text		
    textW = size/0.3
    textH = size/1
    pdb.gimp_context_set_foreground((0, 0, 0))
    textLayer = pdb.gimp_text_fontname(img, None, 0, 0, customtext, 10, 1, size, PIXELS, fontname)
    pdb.gimp_text_layer_set_justification(textLayer, 2)
    pdb.gimp_text_layer_set_letter_spacing(textLayer, 20)
    pdb.gimp_text_layer_set_line_spacing(textLayer, 120)
        
    #Resize text
    pdb.gimp_layer_scale(textLayer, textW, textH, TRUE)
                
    #Making the text centered	
    textLayer = pdb.gimp_image_get_active_layer(img)
    pdb.gimp_image_set_active_layer(img, textLayer)
    wh = pdb.gimp_drawable_width(textLayer)
    hh = pdb.gimp_drawable_height(textLayer)
    w = pdb.gimp_image_width(img)
    h = pdb.gimp_image_height(img)
    pdb.gimp_image_set_active_layer(img,textLayer)
    centerx=w/2
    centery=h/2
    adw=wh/2
    adh=hh/2
    sw=centerx - adw
    sh=centery - adh		
    pdb.gimp_layer_set_offsets(textLayer, sw, sh)
    pdb.gimp_layer_resize_to_image_size(textLayer)
        
    #Rename the text layer and move up
    pdb.gimp_item_set_name(textLayer, "Text")
   
    #Create the edge groves (first design)
    designsLayer = pdb.gimp_layer_new(img, img.width, img.height, RGB, "Logo Desings", 100, LAYER_MODE_NORMAL)
    pdb.gimp_image_add_layer(img, designsLayer, 0)
    pdb.gimp_layer_add_alpha(designsLayer)
    pdb.gimp_drawable_fill(designsLayer, FILL_TRANSPARENT)
    pdb.gimp_image_select_item(img, 2, textLayer)
    pdb.gimp_selection_shrink(img, 9)
    pdb.plug_in_sel2path(img, designsLayer)   
    pdb.gimp_selection_none(img)
    pdb.gimp_context_set_foreground('Black')	
    pdb.gimp_context_set_line_cap_style(0)
    pdb.gimp_context_set_line_join_style(0)
    pdb.gimp_context_set_line_dash_offset(0)
    pdb.gimp_context_set_line_dash_pattern(3, [0.5, 0.3]) 
    pdb.gimp_context_set_line_miter_limit(10)
    pdb.gimp_context_set_line_width(20)
    pdb.gimp_context_set_line_width_unit(PIXELS)
    pdb.gimp_context_set_stroke_method (STROKE_LINE)
    vectors = pdb.gimp_image_get_vectors_by_name(img, _("Selection"))
    pdb.gimp_drawable_edit_stroke_item(designsLayer, vectors)
    pdb.gimp_image_select_item(img, 2, designsLayer)
    pdb.script_fu_selection_rounded_selection(img, designsLayer, 5)
    pdb.gimp_selection_invert(img)
    pdb.gimp_edit_clear(designsLayer)
    pdb.gimp_edit_clear(designsLayer)
    pdb.gimp_selection_none(img)

   #Create the inner dash, dot lines
    pdb.gimp_image_select_item(img, 2, textLayer)
    pdb.gimp_selection_shrink(img, 27)
    pdb.plug_in_sel2path(img, designsLayer)   
    pdb.gimp_selection_none(img)
    pdb.gimp_context_set_foreground('Black')	
    pdb.gimp_context_set_line_cap_style(1)
    pdb.gimp_context_set_line_join_style(0)
    pdb.gimp_context_set_line_dash_offset(0)
    pdb.gimp_context_set_line_dash_pattern(5, [4, 1.5, 0.3, 1.5]) 
    pdb.gimp_context_set_line_miter_limit(10)
    pdb.gimp_context_set_line_width(7)
    pdb.gimp_context_set_line_width_unit(PIXELS)
    pdb.gimp_context_set_stroke_method (STROKE_LINE)
    vectors1 = pdb.gimp_image_get_vectors_by_name(img, (_("Selection")+' #1'))
    pdb.gimp_drawable_edit_stroke_item(designsLayer, vectors1)
    
    #Create small symbols
    pdb.gimp_image_select_item(img, 2, textLayer)
    pdb.gimp_selection_shrink(img, 45)
    pdb.plug_in_sel2path(img, designsLayer)   
    pdb.gimp_selection_none(img)
    pdb.gimp_context_set_foreground('Black')	
    pdb.gimp_brushes_set_brush("Oreo symbol")
    pdb.gimp_context_set_brush_size(25)
    pdb.gimp_context_set_brush_angle(0)
    pdb.gimp_context_set_brush_spacing(1.45)
    pdb.gimp_context_set_brush_default_hardness()
    pdb.gimp_context_set_stroke_method (STROKE_PAINT_METHOD)
    vectors2 = pdb.gimp_image_get_vectors_by_name(img, _("Selection")+' #2')
    pdb.gimp_drawable_edit_stroke_item(designsLayer, vectors2)
	       
    #using map rotate
    pdb.plug_in_map_object(img, textLayer, 
									    0,    # Type of mapping (0=plane,1=sphere,2=box,3=cylinder)
							0.5, 0.5, 2.0,    # viewpoint
							0.5, 0.5, 0.0,    # object pos
							1.0, 0.0, 0.0,    # first axis
							0.0, 1.0, 0.0,    # 2nd axis
						  0.0, 0.0, -10.0,    # axis rotation
										2,    # Type of lightsource (0=point,1=directional,2=none)
						  (255, 255, 255),    # Lightsource color (r,g,b)
						  -0.5, -0.5, 2.0,    # light position
						  -1.0, -1.0, 1.0,    # light direction
			 1.00, 0.60, 0.30, 1.50, 50.0,    # material (amb, diff, refl, spec, high)
									 True,    # antialias
									False,    # tile
									False,    # new image
									 True,    # transparency
									 0.25,    # Sphere/cylinder radius (only used when maptype=1 or 3)
							0.5, 0.5, 0.5,    # box size
									 1.00,    # unused parameter Cylinder length
									 None,    # Box front face (set these to -1 if not used)
									 None,    # Box back face
									 None,    # Box top face									
									 None,    # Box bottom face
									 None,    # Box left face
									 None,    # Box right face
									 None,    # Cylinder top face (unused parameter)
									 None)    # Cylinder bottom face (unused parameter)
                                     
   
    #using map rotate
    pdb.plug_in_map_object(img, designsLayer, 
									    0,    # Type of mapping (0=plane,1=sphere,2=box,3=cylinder)
							0.5, 0.5, 2.0,    # viewpoint
							0.5, 0.5, 0.0,    # object pos
							1.0, 0.0, 0.0,    # first axis
							0.0, 1.0, 0.0,    # 2nd axis
						  0.0, 0.0, -10.0,    # axis rotation
										2,    # Type of lightsource (0=point,1=directional,2=none)
						  (255, 255, 255),    # Lightsource color (r,g,b)
						  -0.5, -0.5, 2.0,    # light position
						  -1.0, -1.0, 1.0,    # light direction
			 1.00, 0.60, 0.30, 1.50, 50.0,    # material (amb, diff, refl, spec, high)
									 True,    # antialias
									False,    # tile
									False,    # new image
									 True,    # transparency
									 0.25,    # Sphere/cylinder radius (only used when maptype=1 or 3)
							0.5, 0.5, 0.5,    # box size
									 1.00,    # unused parameter Cylinder length
									 None,    # Box front face (set these to -1 if not used)
									 None,    # Box back face
									 None,    # Box top face									
									 None,    # Box bottom face
									 None,    # Box left face
									 None,    # Box right face
									 None,    # Cylinder top face (unused parameter)
									 None)    # Cylinder bottom face (unused parameter)                                 
                                     
    #Color the Cookie texture
    pdb.gimp_drawable_colorize_hsl(textLayer, 250, 15, 5)
                                  
    #Bevel and emboss
    pdb.python_layerfx_bevel_emboss(img, designsLayer, 
									                1,   #style inner bevel
								                   65,   #depth 
								                    0,   #direction 
								                    3,   #size 
									                1,   #soften
								                   90,   #angle 
								                   30,   #altitude 
									                6,   #gloss_contour 
							                  "White",   #highlight_color 
								                    5,   #highlight_mode screen
								                   40,   #highlight_opacity
							                  "Black",   #shadow_color 
								                    3,   #shadow_mode multiply
								                   40,   #shadow_opacity 
								                    6,   #surface_contour 
								                FALSE,   #use_texture 
							              "Dried mud",   #pattern 
								                  100,   #scale 
								                  100,   #tex_depth 
								                 TRUE,   #invert 
								                 TRUE)   #merge	
	
    #Create the cookie top
    designsLayer = pdb.gimp_image_get_layer_by_name(img, "Logo Desings")
    designsLayer = pdb.gimp_image_merge_down(img, designsLayer, CLIP_TO_IMAGE)
    cockieT = pdb.gimp_image_get_layer_by_name(img, "Text")
    pdb.gimp_item_set_name(cockieT, "CookieT")    
    
    #3d extrusion
    pdb.script_fu_3d_extrude(img, cockieT, 
										0,  #extrusion type 
									   20,  #extrusion depth 
								       90,  #extrusion direction 
									   90,  #bump azimuth 
									   45,  #bump elevation 
									   65,  #bump depth 
									 0.30,  #bump ambient light 
										0,  #bump curve 
									FALSE,  #invert bump 
									FALSE,  #merge extrusion 
									FALSE,  #overlay with pattern 
									FALSE,  #extrude with pattern 
							  "Dried mud")  #extrision pattern)
    
    #Set new name and resize to image
    cockietop = pdb.gimp_image_get_layer_by_name(img, "Extrusion")
    pdb.gimp_item_set_name(cockietop, "Cookie top")
    pdb.gimp_layer_resize_to_image_size(cockietop)
    
    #Create the creame filling
    non_empty = pdb.gimp_edit_copy(cockietop)
    fillinLayer= pdb.gimp_layer_new(img, img.width, img.height, RGB, "Creame filling", 100, LAYER_MODE_NORMAL_LEGACY)
    pdb.gimp_image_add_layer(img, fillinLayer, 2)
    pdb.gimp_layer_add_alpha(fillinLayer)
    pdb.gimp_drawable_fill(fillinLayer, FILL_TRANSPARENT)
    fillinLayer = pdb.gimp_edit_paste(fillinLayer, FALSE)
    pdb.gimp_floating_sel_anchor(fillinLayer)  
    pdb.gimp_context_set_foreground('White')
    fillinLayer = pdb.gimp_image_get_layer_by_name(img, "Creame filling")
    pdb.gimp_image_select_item(img, 2, fillinLayer)
    pdb.gimp_edit_bucket_fill(fillinLayer, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    pdb.gimp_selection_none(img)
    fillinLayer = pdb.gimp_item_transform_translate(fillinLayer, 0, 10)
    pdb.gimp_layer_resize_to_image_size(fillinLayer)
    
    #Create the bottom cookie
    non_empty = pdb.gimp_edit_copy(cockietop)
    cookiebottom= pdb.gimp_layer_new(img, img.width, img.height, RGB, "Cookie bottom", 100, LAYER_MODE_NORMAL_LEGACY)
    pdb.gimp_image_add_layer(img, cookiebottom, 3)
    pdb.gimp_layer_add_alpha(cookiebottom)
    pdb.gimp_drawable_fill(cookiebottom, FILL_TRANSPARENT)
    cookiebottom = pdb.gimp_edit_paste(cookiebottom, FALSE)
    pdb.gimp_floating_sel_anchor(cookiebottom)  
    pdb.gimp_context_set_foreground('Black')
    cookiebottom = pdb.gimp_image_get_layer_by_name(img, "Cookie bottom")
    pdb.gimp_image_select_item(img, 2, cookiebottom)
    pdb.gimp_edit_bucket_fill(cookiebottom, BUCKET_FILL_FG, LAYER_MODE_NORMAL, 100, 255, FALSE, 0, 0)
    pdb.gimp_selection_none(img)
    cookiebottom = pdb.gimp_item_transform_translate(cookiebottom, 0, 33)
    pdb.gimp_layer_resize_to_image_size(cookiebottom)
    	
    #Set gimp to default
    pdb.gimp_context_set_defaults()
    pdb.gimp_context_set_default_colors()
   	
register(
    "create_oreo_cookie_text",
    "Creates an Oreo cookie text effect",
    "Creates an Oreo cookie text effect",
    "Pocholo",
    "Pocholo",
    "2021",
    "Create an Oreo cookie text",
    "",
    [        
    (PF_TEXT, "customtext", "Text string", 'OREO\nTEXT'),
    (PF_FONT, "font", "Font name", "DISKOPIA2.0 Heavy"),
    (PF_SPINNER, "size", "Text size", 340, (340, 340, 1)),
    ],
    [],
    create_oreo_cookie_text, menu="<Image>/Pocholo-scripts/Create an Oreo cookie text",
    domain=("gimp20", gimp.locale_directory))
main()					